/*******************************************************************************
* (c) Copyright 2014 Biricha Digital Power Limited
* AUTHOR        : Biricha Digital Power Ltd
* CREATION DATE : 03/07/2014
* COPYRIGHT     : Copyright Biricha Digital Power Limited 2014. All rights
*                 reserved. Reproduction in whole or part is prohibited without
*                 written consent of the copyright owner. You may receive a free
*                 commercial license by contacting Biricha Digital. Do not
*                 remove or change this copyright notice.
*
*******************************************************************************/

#include "bdp.h"

void ADC_config(ADC_Early_Interrupt IntMode, ADC_Order Order, INT_Priority Priority)
{
    ADCONbits.FORM    = 0;       // Integer data format
    ADCONbits.EIE     = IntMode; // Early Interrupt disabled
    ADCONbits.ORDER   = Order;   // Convert even channel first
    ADCONbits.SEQSAMP = 0;       // Select simultaneous sampling
    ADCONbits.ADCS    = 5;       // ADC clock = FADC/6 = 120MHz / 6 = 20MHz,
				 // 12*Tad = 1.6 MSPS
    IFS6bits.ADCP0IF  = 0;	 // Clear ADC interrupt flag
    IPC27bits.ADCP0IP = Priority; // Set ADC interrupt priority
    IEC6bits.ADCP0IE  = Priority!=INT_Priority_Disabled; // Enable the ADC Pair 0 interrupt

    ADPCFGbits.PCFG0  = 0; 	 // Current Measurement for Buck for STARTER_KIT
                                 // Voltage Measurement for Buck for BIRICHA_KIT and ANDY_KIT
    ADPCFGbits.PCFG1  = 0; 	 // Voltage Measurement for Buck for STARTER_KIT

    ADPCFGbits.PCFG5 = 0; 	 // Voltage Measurement for Ext POT2 for STARTER_KIT
    ADPCFGbits.PCFG6 = 0; 	 // Voltage Measurement for Ext POT1 for STARTER_KIT


    ADSTATbits.P0RDY   = 0; 	 // Clear Pair 0 data ready bit
    ADCPC0bits.IRQEN0  = 1; 	 // Enable ADC Interrupt for Buck 1 control loop
    ADCPC0bits.TRGSRC0 = 4; 	 // ADC Pair 0 triggered by PWM1

    //ADSTATbits.P2RDY   = 0; 	 // Clear Pair 2 data ready bit
    //ADCPC1bits.IRQEN2  = 0;      // Disable ADC Interrupt for Vin & POT2
    //ADCPC1bits.TRGSRC2 = 4; 	 // ADC Pair 2 triggered by PWM1

    ADCONbits.ADON = 1;		 // Enable the ADC Module early for ADC Settling Time
}