/*******************************************************************************
* (c) Copyright 2014 Biricha Digital Power Limited
* AUTHOR        : Biricha Digital Power Ltd
* CREATION DATE : 03/07/2014
* COPYRIGHT     : Copyright Biricha Digital Power Limited 2014. All rights
*                 reserved. Reproduction in whole or part is prohibited without
*                 written consent of the copyright owner. You may receive a free
*                 commercial license by contacting Biricha Digital. Do not
*                 remove or change this copyright notice.
*
*******************************************************************************/


#ifndef BDP_ADC_H
#define	BDP_ADC_H


#define ADC0_clrInt() do { ADSTATbits.P0RDY = 0; \
                           IFS6bits.ADCP0IF = 0; \
                      } while(0)

typedef enum ADC_Early_Interrupt
{
    ADC_Early_Interrupt_Disabled = 0, // Interrupt is generated after second conversion is completed
    ADC_Early_Interrupt_Enabled = 1   //Interrupt is generated after first conversion is completed
}ADC_Early_Interrupt;

typedef enum ADC_Order
{
    ADC_Order_Even = 0, // Even numbered analog input is converted first, followed by conversion of odd numbered input
    ADC_Order_Odd = 1 // Odd numbered analog input is converted first, followed by conversion of even numbered input
}ADC_Order;

extern void ADC_config(ADC_Early_Interrupt IntMode, ADC_Order Order, INT_Priority Priority);



#endif	/* BDP_ADC_H */

