/*******************************************************************************
* (c) Copyright 2014 Biricha Digital Power Limited
* AUTHOR        : Biricha Digital Power Ltd
* CREATION DATE : 03/07/2014
* COPYRIGHT     : Copyright Biricha Digital Power Limited 2014. All rights
*                 reserved. Reproduction in whole or part is prohibited without
*                 written consent of the copyright owner. You may receive a free
*                 commercial license by contacting Biricha Digital. Do not
*                 remove or change this copyright notice.
*
*******************************************************************************/

#include "bdp.h"


void CMP1_config(CMP_DAC_Output DacOutput)
{ 
// Setup Comparator 1A to monitor Buck Current Sense, if the CS exceed the set limit
// CMPDAC1, the comparator will shut off the PWM (in Cycle-by-Cycle Fault Mode)

 //TRISBbits.TRISB3  = 1; //DACout pin

 CMPCON1bits.CMPON   = 0;	  // Disable Comparator
 CMPCON1bits.CMPSIDL = 0;	  // Continue module operation in idle mode
 CMPCON1bits.INSEL   = 0;	  // Select CMP1A input pin
 CMPCON1bits.EXTREF  = 0;	  // Internal ref selected
 CMPCON1bits.DACOE   = DacOutput;  // Output to DACOUT pin disabled
 CMPCON1bits.HGAIN   = 1;	  // 0=x1 1=x1.8 Gain
 CMPCON1bits.CMPPOL  = 0;	  // Comparator output is non-inverted
 CMP1_setDac(0);                  // (Comp_trip_point/1023)*AVDD
				  // HGain * Avdd/2 = 2.97V = 1023
				  // Set to 1.5A max PWM Fault limit
				  // 1.5A / 60 (CT ratio) x 120 Ohms = 3V
 CMPCON1bits.RANGE   = 1;	  // Select High Range, 1 = AVDD/2 0 = 1.2v
 CMPCON1bits.HYSSEL  = 1;	  // 15mV Hysterisis level selected
 CMPCON1bits.HYSPOL  = 0;	  // Hysterisis applied to rising edge
 CMPCON1bits.FCLKSEL = 1;	  // Digital Filter pulse strecher to operate on 0=sys 1=PWM clock
 CMPCON1bits.FLTREN  = 1;	  // Digital filter is enabled and the system clock
				  // being used. In order for the comparator to trip
			          // the CMP input signal must be above the treshold
			          // for at least 75ns or else will not set the CMP */

 RPINR29bits.FLT1R = 0b100000;	  // Assign Fault 1 to Virtual Pin RP32
 RPOR16bits.RP32R  = 0b100111;	  // Assign CMP1 output to Virtual Pin RP32

 if (DacOutput)
 {
    RPOR6bits.RP13R = 0b100111;	  // To Debug - Assign CMP1 output to Virtual Pin RP13,
 }

 CMPCON1bits.CMPON     = 1;	  // Enable Comparator
				  // Allow ~ 1uS after Enabling Comparator prior to
				  // enabling any CMP driven interrups.
 //PDC1 = MAX_DUTY; //set max duty
}
