/*******************************************************************************
* (c) Copyright 2014 Biricha Digital Power Limited
* AUTHOR        : Biricha Digital Power Ltd
* CREATION DATE : 03/07/2014
* COPYRIGHT     : Copyright Biricha Digital Power Limited 2014. All rights
*                 reserved. Reproduction in whole or part is prohibited without
*                 written consent of the copyright owner. You may receive a free
*                 commercial license by contacting Biricha Digital. Do not
*                 remove or change this copyright notice.
*
*******************************************************************************/

#include "bdp.h"

//#define SIMULATOR

void SYS_config(void)
{
 // Configure Oscillator to operate the device at 40Mhz
 // Fosc= Fin*M/(N1*N2), Fcy=Fosc/2
 // Fosc= 7.37*(43)/(2*2)=80Mhz for Fosc, Fcy = 40Mhz

 // Configure PLL prescaler, PLL postscaler, PLL divisor
 PLLFBD             = 41;  // M = PLLFBD + 2
 CLKDIVbits.PLLPOST = 0;   // N1 = 2
 CLKDIVbits.PLLPRE  = 0;   // N2 = 2

 __builtin_write_OSCCONH(0x01);		// New Oscillator selection FRC w/ PLL
 __builtin_write_OSCCONL(0x01);  	// Enable Switch

#ifndef SIMULATOR
 while(OSCCONbits.COSC != 0b001);	// Wait for Oscillator to switch to FRC w/ PLL
 while(OSCCONbits.LOCK != 1);		// Wait for Pll to Lock
#endif

 // Now setup the ADC and PWM clock for 120MHz
 //   ((FRC * 16) / APSTSCLR ) = (7.37MHz * 16) / 1 = 117.9MHz

 ACLKCONbits.FRCSEL   = 1;	  // FRC provides input for Auxiliary PLL (x16)
 ACLKCONbits.ENAPLL   = 1;	  // Enable Auxiliary PLL
 ACLKCONbits.SELACLK  = 1;	  // Auxiliary Ocillator provides clock source for PWM & ADC
 ACLKCONbits.APSTSCLR = 7;	  // Divide Auxiliary clock by 1

#ifndef SIMULATOR
 while(ACLKCONbits.APLLCK != 1);  // Wait for Auxiliary PLL to Lock
#endif
}