/*******************************************************************************
* (c) Copyright 2014 Biricha Digital Power Limited
* FILE          : main.c
* AUTHOR        : Biricha Digital Power Ltd
* PROJECT       : bdp_lib
* Target System : dsPIC33F
* CREATION DATE : 03/07/2014
* COPYRIGHT     : Copyright Biricha Digital Power Limited 2014
*                 All rights reserved. Reproduction in whole or part is
*                 prohibited without written consent of the copyright
*                 owner.
* DESCRIPTION   :
*
* This file includes board specific defines which can be easily changed at a
* later date.
*
*
*******************************************************************************/
#ifndef BOARD_H
#define	BOARD_H


#define STARTER_KIT


#ifdef	__cplusplus
extern "C" {
#endif

#if defined(STARTER_KIT)
    #define SetIsrPin(v)  LATBbits.LATB12   = (v)
    #define DirIsrPin(v)  TRISBbits.TRISB12 = (v)
    #define SetIdlePin(v) LATBbits.LATB13   = (v)
    #define ToggleIdlePin() LATBbits.LATB13 ^= 1
    #define DirIdlePin(v) TRISBbits.TRISB13 = (v)	
    #define DirSwitchPin(v)   TRISBbits.TRISB8 = (v)
	#define SW1	PORTBbits.RB8
#else
#error
#endif

#define DEBOUNCE_DELAY 	80	// Push button debounce delay, expressed in ms


/* Define default interrupt. If not interrupt is defined the MCU will jump here
 */
void __attribute__((__interrupt__, no_auto_psv)) _DefaultInterrupt()
{
    int a = 0;
    while(1)
    {
        a++;
    }
}


#ifdef	__cplusplus
}
#endif

#endif	/* BOARD_H */

